//+------------------------------------------------------------------+
//|                                                         iZSR.mq4 |
//|                                 |
//|                          http://kroufr.ru/content/view/3449/243/ |
//+------------------------------------------------------------------+
#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

//---- input parameters
extern int periods=12;
//---- buffers
double ExtMapBuffer1[];
double MedianArray[];
int ArrayMidPoint;
int ArraySizee;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   ArraySizee=periods*4;
   ArrayResize(MedianArray,ArraySizee);
   ArrayMidPoint=periods*2;
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
 
   SetIndexDrawBegin(0,periods);
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
         int limit=Bars-IndicatorCounted()-1;

            for(int i=limit;i>=0;i--){
                  for(int j=0;j<periods;j++){
                     int k=i+j;
                     MedianArray[j*4]=Open[k];
                     MedianArray[j*4+1]=High[k];              
                     MedianArray[j*4+2]=Low[k];
                     MedianArray[j*4+3]=Close[k];
                  }
               ArraySort(MedianArray,WHOLE_ARRAY,0,MODE_ASCEND);//
               double Median=(MedianArray[ArrayMidPoint-1]+MedianArray[ArrayMidPoint])/2;
               double SumDist=0;
                  for(j=0;j<ArraySizee;j++){
                     SumDist+=(MedianArray[j]-Median); 
                  }
               ExtMapBuffer1[i]=SumDist/ArraySizee;
            }
   return(0);
  }
//+------------------------------------------------------------------+